#include <windows.h>
#include <stdio.h>

BOOL LoadSeDebugPrivilege (void)
{
	HANDLE	hToken;
	LUID	Val;
	TOKEN_PRIVILEGES tp;

	if (!OpenProcessToken (GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
		return FALSE;

	if (!LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &Val))
	{
		CloseHandle(hToken);
		return FALSE;
	}
	
	tp.PrivilegeCount = 1;
	tp.Privileges[0].Luid = Val;
	tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

	if (!AdjustTokenPrivileges(hToken, FALSE, &tp, sizeof (tp), NULL, NULL))
	{
		CloseHandle(hToken);	
		return FALSE;
	}

	CloseHandle(hToken);

	return TRUE;
}

void GetItemLevel (void)
{
	HWND	hD2;
	DWORD	pID;
	HANDLE	pD2;
	DWORD	read;
	
	DWORD	itemdata[12];
	DWORD	unitdata[6];
	DWORD	inventory[9];
	DWORD	playerUnit[25];
	DWORD	addr;

	hD2 = FindWindow ("Diablo II", NULL);
	if (!hD2)
	{
		puts ("Couldn't find Diablo II window handle, please check you are running Diablo II.");
		return;
	}

	GetWindowThreadProcessId (hD2, &pID);

	pD2 = OpenProcess (PROCESS_VM_READ|PROCESS_VM_OPERATION, FALSE, pID);
	if (!pD2)
	{
		puts ("Couldn't open Diablo II process, perhaps you need to use D2Loader.");
		return;
	}
	
	ReadProcessMemory (pD2, (VOID *)0x6FBCC1E0, &addr, sizeof(addr), &read);
	ReadProcessMemory (pD2, (VOID *)addr, playerUnit, sizeof(playerUnit), &read);
	if (read != sizeof(playerUnit))
	{
		puts ("Couldn't read playerUnit, please check you are in game.");
		return;
	}

	ReadProcessMemory (pD2, (VOID *)playerUnit[24], inventory, sizeof(inventory), &read);
	if (read != sizeof(inventory))
	{
		puts ("Couldn't read inventory, please check you are in game.");
		return;
	}

	ReadProcessMemory (pD2, (VOID *)inventory[8], unitdata, sizeof(unitdata), &read);
	if (read != sizeof(unitdata))
	{
		puts ("Couldn't read unit data, please check you picked up the item onto the cursor.");
		return;
	}

	ReadProcessMemory (pD2, (VOID *)unitdata[5], itemdata, sizeof(itemdata), &read);
	if (read != sizeof(itemdata))
	{
		puts ("Couldn't read item data, please check you picked up the item onto the cursor.");
		return;
	}

	CloseHandle (pD2);

	printf ("Item level of cursor item: %d\n", itemdata[11]);
}

int main (int argc, char *argv[])
{
	char	dummy[4];
	LoadSeDebugPrivilege ();

	puts ("D2ViewItemLevel v1.11b. Pickup the item in your inventory, then press\n"
			"ENTER in this window to view the item level. Press Ctrl+C to exit.\n");

	while (fgets (dummy, 2, stdin))
	{
		GetItemLevel ();
	}
}
